#ifndef unicode_jis208_hh
#define unicode_jis208_hh

#include "charsets.hh"

#define jis208_SO 0x0E /* shift out */
#define jis208_SI 0x0F /* shift in */
class jis208 : public charset
{
    enum jistate { ascii, st201latin, st201kana,
                   st78, st83,
                   st78a83, st78b83,
                   st212, st212a, st212b,
                   gotesc, gotsulku, gotsulku2, gotdolla };
    jistate instate, outstate;
    charmap *jis201in, *jis201out;
    charmap *jis208in, *jis208out;
    charmap *jis212in, *jis212out;
    unsigned char cache;
private:
    void setoutstate(string &ss, jistate newstate);
public:
    jis208();
    virtual ~jis208();
    virtual const wstring c2uni(const string &s, bool html=false);
    virtual const string uni2c(const wstring &s);
};

#endif
