#include <iostream>
#include "parse.hh"

void Body::comment(const string &s)
{
    cout << "Comment(\"" << s << "\")\n";
}

void Body::add(const wstring &s)
{
    cout << "Body(\"" << conv.wide2str(s) << "\")\n";
}

void Body::add(const Elem &e)
{
    cout << "tag: \"" << e.tagname << "\"";
    if(!e.set)cout << " (clear)";
    cout << "\n";
    map<string, wstring>::const_iterator i;
    for(i = e.parms.begin(); i != e.parms.end(); ++i)
    {
        cout << "  [" << i->first << "] = \"" << conv.wide2str(i->second) << "\"\n";
    }
}


void Page::Parse(const string &s)
{
    unsigned a=0, b=s.size();
    
    string strs;
    
    while(a < b && isspace(s[a]))++a;
    
    while(a < b)
    {
        if(s[a] == '<')
        {
            if(strs.size()) { body.add(conv.html2wstring(strs)); strs = ""; }
            if(++a==b)break;
            if(s.substr(a, 3) == "!--")
            {
                a += 3;
                unsigned c = s.find("-->", a);
                if(c==s.npos) { body.comment(s.substr(a)); break; }
                body.comment(s.substr(a, c-a));
                a = c+3;
                continue;
            }
            Elem e;
            do if(!isspace(s[a]))break; while(++a < b);
            if(a==b)break;
            if(s[a] == '/') { e.set = false; if(++a==b)break; }
            while(a < b && s[a]!='>' && s[a]!='=' && !isspace(s[a]))
                e.tagname += toupper(s[a++]);
            while(a < b && s[a] != '>')
            {
                while(a < b && isspace(s[a]))++a;
                if(a==b || s[a]=='>')break;
                string s1, s2;
                bool laina = false;
                if(s[a]=='"') { laina=true; if(++a==b)break; }
                while(a < b)
                {
                    if(laina) { if(s[a]=='"') { ++a; break; } }
                    else { if(s[a]=='>' || s[a]=='=' || isspace(s[a])) break; }
                    s1 += toupper(s[a++]);
                }
                if(a == b)break;
                if(s[a]=='=')
                {
                    laina = false;
                    if(++a==b)break;
                    if(s[a]=='"') { laina=true; if(++a==b)break; }
                    while(a < b)
                    {
                        if(laina) { if(s[a] == '"') { ++a; break; } }
                        else { if(s[a]=='>' || isspace(s[a])) break; }
                        s2 += s[a++];
                    }
                }
                e.parms[s1] = conv.html2wstring(s2);
            }
            ++a; /* skip > */
            body.add(e);
        }
        else
            strs += s[a++];
    }
    if(strs.size())
        body.add(conv.html2wstring(strs));
}
