#include "shift_jis.hh"

const wstring shift_jis::c2uni(const string &s, bool html)
{
    wstring ss;
    unsigned a, b=s.size();
    for(a=0; a<b; ++a)
    {
        wchar_t t;
        if(cache)
        {
            t = 256*cache + (unsigned char)s[a];
    HaveChar:
            if(t >= 0 && t < 32)
                ss += t;
            else
            {
                charmap::const_iterator i = in->find(t);
                if(i == in->end())
                {
                    ss += cache;
                    ss += (unsigned char)s[a];
                }
                else
                {
                    //printf("Became %u\n", i->second);
                    ss += i->second;
                }
            }
            cache = 0;
        }
        else
        {
            if(html)
            {
                ss += TryParseEntities(s, a);
                if(a==b)break;
            }
            cache = s[a];
            
            //printf("Have char: %02X\n", cache);
            
            /* 00..7F are ascii (do lookup)
             * A0..DF are jis201 (do lookup (sjis class has them))
             * 8000..9FFF and E000..FFFF are double byte (do lookup)
             */
            if(cache < 0x80 || (cache>=0xA0 && cache<0xE0))
            {
                t = cache;
                cache = 0;
                //printf("short: ");
                goto HaveChar;
            }
        }
    }
    return ss;
}

const string shift_jis::uni2c(const wstring &s)
{
    string ss;
    unsigned a, b=s.size();
    for(a=0; a<b; ++a)
    {
        charmap::const_iterator i = out->find(s[a]);
        if(i == out->end())
        {
            if((unsigned char)s[a] < 32)
                ss += (char)s[a];
            else
                ss += '?';
        }
        else if(i->second >= 0x100)
        {
            ss += (char)(i->second >> 8);
            ss += (char)(i->second & 255);
        }
        else
            ss += (char)i->second;
    }
    return ss;
}
